"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDesignTokens = exports.default = exports.DesignTokenContext = void 0;

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _react = _interopRequireWildcard(require("react"));

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const DesignTokenContext = /*#__PURE__*/_react.default.createContext({});

exports.DesignTokenContext = DesignTokenContext;

const useDesignTokens = () => (0, _react.useContext)(DesignTokenContext);

exports.useDesignTokens = useDesignTokens;

var _default = (options = {}) => ({
  name: '@modern-js/plugin-design-token',
  setup: () => ({
    hoc({
      App
    }, next) {
      const DesignTokenAppWrapper = props => {
        const {
          token = {},
          useStyledComponentsThemeProvider = false,
          useDesignTokenContext = false
        } = options;

        if (useStyledComponentsThemeProvider && useDesignTokenContext) {
          const {
            ThemeProvider
          } = require('@modern-js/runtime-core/styled');

          return /*#__PURE__*/(0, _jsxRuntime.jsx)(ThemeProvider, {
            theme: token,
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(DesignTokenContext.Provider, {
              value: token,
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(App, _objectSpread({}, props))
            })
          });
        } else if (useStyledComponentsThemeProvider) {
          const {
            ThemeProvider
          } = require('@modern-js/runtime-core/styled');

          return /*#__PURE__*/(0, _jsxRuntime.jsx)(ThemeProvider, {
            theme: token,
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(App, _objectSpread({}, props))
          });
        } else if (useDesignTokenContext) {
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(DesignTokenContext.Provider, {
            value: token,
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(App, _objectSpread({}, props))
          });
        } else {
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(App, _objectSpread({}, props));
        }
      };

      return next({
        App: (0, _hoistNonReactStatics.default)(DesignTokenAppWrapper, App)
      });
    }

  })
});

exports.default = _default;